## defines necessary macros 
include(net/tree.m4)

## First, define the names of all the atoms.
atom(D)
atom(A)
atom(N)
atom(V)
atom(P)

## Second, for each binary tree to be learned, specify its name and
## the names of its left and right subtrees.  the subtrees must be either
## atoms or trees that have been already defined.

tree(DN,D,A)
tree(AN,A,N)
tree(DAN,D,AN)
tree(VDN,V,DN)
tree(PDN,P,DN)
tree(AAN,A,AN)
tree(DNV,DN,V)
tree(VPDN,V,PDN)
tree(VDAN,V,DAN)
tree(PDAN,P,DAN)
tree(AAAN,A,AAN)
tree(DAAAN,D,AAAN)
tree(DNPDN,DN,PDN)
tree(DNVDAN,DN,VDAN)
tree(DANVPDN,DAN,VPDN)
