#define Nargs 32 		/* max # of arguments for a command */
#define Largs 128  		/* max length of command/argument */
#define Lcomm 128		/* command may get long in "=" statement */
#define BUFSIZE 256		/*size of buffer to hold command&args */
#define BUFFMT "%256s "		/* scanf fmt for reading a str into buffer*/

#ifndef IF
#define IF(x, y)        if( strcmp(x, y) == NULL )
#endif IF
#define EQL(x, y)	(strcmp(x, y) == NULL)

#ifndef AtoF
#define AtoF( s, n ) sscanf( s, "%f", &n ) /* ascii to float conversion */
#define AtoI( s, i ) sscanf( s, "%d", &i ) /* ascii to integer conversion */
#endif AtoF

#ifndef ON
typedef char	BINARY;
#define ON	'1'
#endif
#ifndef OFF
#define OFF	'\0'
#endif

#define Lcommname 16

typedef struct _command {
	char	name[ Lcommname ];
	int	(*func)();
} COMMAND;

extern COMMAND	* which_command ();
extern char	* get_prompt ();

extern COMMAND	Command[];
extern int	Ncommand;

#define Malias 128
typedef struct {
  char *name;
  char *substitute;
  int  leng;
} ALIAS;
extern ALIAS *Alias[];	/* command level aliases */
