#define Nmsg 200			/* error msg can be fairly long */
char	ERR_MSG[Nmsg];
int	ERR_FLAG;
#define OK 1
#define ERR 0
#define STOP 2
#define EXIT 3
#define END 4
#define CONT 5
#define READWEIGHTS 6
					/* error handling macros */
#define Erreturn( msg )           { strcpy(ERR_MSG, msg); return ( ERR ); }
#define Erreturn1( msg, x )       { sprintf(ERR_MSG, msg, x); \
				      return ( ERR ); }
#define Erreturn2( msg, x, y )    { sprintf(ERR_MSG, msg, x, y); \
				      return ( ERR ); }
#define Erreturn3( msg, x, y, z ) { sprintf(ERR_MSG, msg, x, y, z); \
				      return( ERR ); }
#define Erreturn4( msg, w, x, y, z ) { sprintf(ERR_MSG, msg, w, x, y, z); \
				      return( ERR ); }
#define CheckInterrupt(str) \
  if( INTERRUPT ) { printf("interrupt in %s.\n", str ); \
		    add_prompt(str); \
		    if(interact() == EXIT) { reset_prompt(); return( ERR ); } \
		    reset_prompt(); \
		  }
extern int 	INTERRUPT ;		/* interrupt from the keyboard */
extern void	*onintr();		/* interrupt handling function */
#define INTR_FILE 10			/* interrupt at next line in file */
#define INTR_CYC 11			/* interrupt at next cycle */
#define INTR_PAT 12			/* interrupt at next pattern */
#define INTR_ACT 13			/* intevrrupt at next action */
					/* this enters the debug mode */
#define INTR_LIST 14			/* intevrrupt at next list item */

extern unsigned inWhat;			/* flag to indicate process it's in */
#define inProc 0x1			/* flag on if inside procedure */
#define inCycle 0x2			/* inside cycle */
#define inList 0x4			/* inside a list */
#define inFile 0x8			/* reading a file */
#define inPattern 0x16			/* going through patterns */
#define Starting(x) (inWhat |= (x))	/* add flag */
#define Ending(x) (inWhat &= ~(x))	/* remove flag */

#define IfErr( x ) 	if( (x) == ERR )
#define IfEOF( x )	if( (x) == EOF )
#define Err( x )        ( (x) == ERR )
#define DoOrDie(x) 	IfErr(x) handle( ERR_FLAG )
