# line 2 "../src/expr.y"
#include <stdio.h>
#include <ctype.h>
#include "alloc.h"
#include "net.h"
#include "arith.h"
#include "error.h"
/* #include "msg.h"  for debugging */
double  atof();
int i, yyDebug;
int yyInProc; /*  procedure arguments parsing */

# line 15 "../src/expr.y"
typedef union  {
  int	ival;
  float fval;
  VECTOR vval;
  RANGE rval;
  EXPRESS *eval;
  PROCARG *aval;
  int  (*funcval)();
  char  *sval;
  char  cval;
} YYSTYPE;
# define INTGR 257
# define REAL 258
# define VEC 259
# define VEC2 260
# define OP 261
# define MULTI 262
# define ASSIGN 263
# define CMP 264
# define LOGIC 265
# define KW_PROC 266
# define KW_LAYER 267
# define KW_CONNECT 268
# define KW_EXPR 269
# define NEWNAME 270
# define PROCNAME 271
# define FUNC 272
# define RANDOMFUNC 273
# define TO 274
# define UMINUS 275
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern short yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

# line 146 "../src/expr.y"

#include <stdio.h>
#include <strings.h>
#define BUFSIZE 512
EXPRESS *Expression, *ex;
char Buf[BUFSIZE], *NextChar, *OrigStr;
NETWORK *yyNet;
PROCED *yyProc;
void *substitute_defined_str();

EXPRESS *
find_expression( net, str ) 
NETWORK *net;  char *str;
{
  yyNet = net;
  NextChar = strncpy( Buf, OrigStr = str, BUFSIZE );
  substitute_defined_str( Buf, net );
  *ERR_MSG = NULL;
  set_yydebug();	
  Expression = NULL;
  if( yyparse() ) {/* syntax error */ 
    if( Expression ) delete_expression(Expression); Expression=NULL;
    Erreturn2("%s: in %s", ERR_MSG, str );
  }
  IfErr( Expression ) Erreturn2("%s: in %s", ERR_MSG, str );
  Expression->name = new_string( str, Expression->name );
  return( Expression );
}

#define YYDEBUG 1

yyerror(s) char *s; {
	/* fprintf(stderr, "%s in %s\n", s, OrigStr );    */
}
/*
input()
{
  char c;
  if( (c = *NextChar) == NULL ) return(0);
  NextChar++ ;
  return( c );
}
output(c) char c; {}

unput(c) char c; {
  if(NextChar>Buf) *(--NextChar) = c;
}
*/
#include "lex.yy.c"
short yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 37
# define YYLAST 327
short yyact[]={

  19,   3,  54,  57,  15,  13,   4,  14,  48,  16,
  24,   3,  24,  18,  41,  -1,   4,  51,  23,  -1,
   3,   9,  19,  -1,   1,   4,  15,  13,   0,  14,
   0,  16,  19,   0,   0,   0,  15,  13,   0,  14,
  19,  16,  40,  47,  15,  13,   0,  14,   0,  16,
   0,   0,   0,  24,  42,  50,  18,  19,   0,   0,
  46,  15,  13,   0,  14,   0,  16,  19,   0,   0,
  45,  15,  13,   0,  14,  24,  16,  56,  18,  15,
  13,   0,  14,   0,  16,  24,  20,  55,  18,   0,
  15,   0,   0,  24,  19,  16,  18,   0,  15,  13,
   0,  14,   0,  16,   0,   0,  15,  13,  20,  14,
  24,  16,   0,  18,   0,   0,   0,   0,  20,   0,
  24,   0,   0,  18,   0,   0,  20,   0,  24,   0,
   0,  18,   0,   0,   0,   0,   0,   0,   0,  24,
   0,   0,  18,  20,   0,   0,   0,  24,   0,   0,
  18,   0,   0,  20,   0,  24,  43,   2,  18,   0,
  25,  26,  27,  28,   0,   0,   0,   0,   0,  29,
  30,  31,  32,  33,  34,  35,  36,  37,  38,  39,
  20,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,  52,  53,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,  44,  10,
   7,   8,   0,   0,  17,  12,  21,  22,  11,  10,
   7,   8,   0,   5,   6,   0,  49,  44,  10,   7,
   8,   0,   0,   5,   6,   0,  17,  12,  21,  22,
   0,   0,   5,   6,   0,   0,  17,  12,  21,  22,
   0,   0,   0,   0,  17,  12,  21,  22,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,  17,  12,  21,  22,   0,   0,   0,   0,   0,
   0,  17,  12,  21,  22,   0,   0,   0,   0,  17,
   0,  21,   0,   0,   0,   0,   0,   0,   0,   0,
  17,   0,   0,   0,   0,   0,   0,   0,  17,  12,
  21,  22,   0,   0,   0,   0,  17 };
short yypact[]={

 -29,-1000,  56, -29, -29, -29, -29,-1000,-1000,-1000,
-1000,-1000, -29, -29, -29, -29, -29, -29, -29, -29,
 -29, -29, -29, -77, -39,  29, -79,  19,   2,  56,
  48,  48, -81, -81, -81, -81,  37,  37,  64,  37,
-1000, -20, -83, -38, -27,-1000,-1000,-1000, -29, -29,
-1000,-255,  -6, -16, -90,-1000,-1000,-1000 };
short yypgo[]={

   0,  24,  23, 156,  18,  21,  19,  15 };
short yyr1[]={

   0,   1,   1,   6,   6,   6,   2,   2,   2,   7,
   7,   3,   3,   3,   3,   3,   3,   3,   3,   3,
   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
   3,   3,   5,   5,   4,   4,   4 };
short yyr2[]={

   0,   0,   1,   2,   4,   5,   0,   1,   3,   1,
   2,   3,   3,   3,   3,   3,   3,   3,   3,   3,
   3,   3,   3,   2,   3,   3,   2,   3,   1,   1,
   6,   1,   1,   1,   5,   3,   5 };
short yychk[]={

-1000,  -1,  -3,  40,  45, 272, 273, 259, 260,  -5,
 258, 257, 263,  43,  45,  42,  47, 262,  94,  38,
 124, 264, 265,  -4,  91,  -3,  -3,  -3,  -3,  -3,
  -3,  -3,  -3,  -3,  -3,  -3,  -3,  -3,  -3,  -3,
  -4,  91,  93,  -3, 257,  41,  41,  41,  91, 274,
  93,  44,  -3,  -3, 257,  93,  93,  93 };
short yydef[]={

   1,  -2,   2,   0,   0,   0,   0,  28,  29,  31,
  32,  33,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,  26,   0,   0,  23,   0,   0,  12,
  13,  14,  15,  16,  17,  18,  19,  20,  21,  22,
  27,   0,   0,   0,  33,  11,  24,  25,   0,   0,
  35,   0,   0,   0,   0,  30,  34,  36 };
#ifndef lint
static	char yaccpar_sccsid[] = "@(#)yaccpar	1.2 89/06/15 Copyr 1989 Sun Micro; JLE";
/* from SunOS4.0.3 @(#)yaccpar 1.6 88/02/08 SMI"; *//* from UCB 4.1 83/02/01 */
#endif

# define YYFLAG -1000
# define YYERROR goto yyerrlab
# define YYACCEPT return(0)
# define YYABORT return(1)

/*	parser for yacc output	*/

#ifdef YYDEBUG
int yydebug = 0; /* 1 for debugging */
#endif
YYSTYPE yyv[YYMAXDEPTH]; /* where the values are stored */
int yychar = -1; /* current input token number */
int yynerrs = 0;  /* number of errors */
short yyerrflag = 0;  /* error recovery flag */

yyparse() {

	short yys[YYMAXDEPTH];
	short yyj, yym;
	register YYSTYPE *yypvt;
	register short yystate, *yyps, yyn;
	register YYSTYPE *yypv;
	register short *yyxi;

	yystate = 0;
	yychar = -1;
	yynerrs = 0;
	yyerrflag = 0;
	yyps= &yys[-1];
	yypv= &yyv[-1];

 yystack:    /* put a state and value onto the stack */

#ifdef YYDEBUG
	if( yydebug  ) printf( "state %d, char 0%o\n", yystate, yychar );
#endif
		if( ++yyps>= &yys[YYMAXDEPTH] ) { yyerror( "yacc stack overflow" ); return(1); }
		*yyps = yystate;
		++yypv;
		*yypv = yyval;

 yynewstate:

	yyn = yypact[yystate];

	if( yyn<= YYFLAG ) goto yydefault; /* simple state */

# ifdef YYEUCCCOUNT
	if( yychar<0 ) if( (yychar=yyeuclex())<0 ) yychar=0;
# else
	if( yychar<0 ) if( (yychar=yylex())<0 ) yychar=0;
# endif

	if( (yyn += yychar)<0 || yyn >= YYLAST ) goto yydefault;

	if( yychk[ yyn=yyact[ yyn ] ] == yychar ){ /* valid shift */
		yychar = -1;
		yyval = yylval;
		yystate = yyn;
		if( yyerrflag > 0 ) --yyerrflag;
		goto yystack;
		}

 yydefault:
	/* default state action */

	if( (yyn=yydef[yystate]) == -2 ) {

# ifdef YYEUCCCOUNT
		if( yychar<0 ) if( (yychar=yyeuclex())<0 ) yychar = 0;
# else
		if( yychar<0 ) if( (yychar=yylex())<0 ) yychar = 0;
# endif

		/* look through exception table */

		for( yyxi=yyexca; (*yyxi!= (-1)) || (yyxi[1]!=yystate) ; yyxi += 2 ) ; /* VOID */

		while( *(yyxi+=2) >= 0 ){
			if( *yyxi == yychar ) break;
			}
		if( (yyn = yyxi[1]) < 0 ) return(0);   /* accept */
		}

	if( yyn == 0 ){ /* error */
		/* error ... attempt to resume parsing */

		switch( yyerrflag ){

		case 0:   /* brand new error */

			yyerror( "syntax error" );
		yyerrlab:
			++yynerrs;

		case 1:
		case 2: /* incompletely recovered error ... try again */

			yyerrflag = 3;

			/* find a state where "error" is a legal shift action */

			while ( yyps >= yys ) {
			   yyn = yypact[*yyps] + YYERRCODE;
			   if( yyn>= 0 && yyn < YYLAST && yychk[yyact[yyn]] == YYERRCODE ){
			      yystate = yyact[yyn];  /* simulate a shift of "error" */
			      goto yystack;
			      }
			   yyn = yypact[*yyps];

			   /* the current yyps has no shift onn "error", pop stack */

#ifdef YYDEBUG
			   if( yydebug ) printf( "error recovery pops state %d, uncovers %d\n", *yyps, yyps[-1] );
#endif
			   --yyps;
			   --yypv;
			   }

			/* there is no state on the stack with an error shift ... abort */

	yyabort:
			return(1);


		case 3:  /* no shift yet; clobber input char */

#ifdef YYDEBUG
			if( yydebug ) printf( "error recovery discards char %d\n", yychar );
#endif

			if( yychar == 0 ) goto yyabort; /* don't discard EOF, quit */
			yychar = -1;
			goto yynewstate;   /* try again in the same state */

			}

		}

	/* reduction by production yyn */

#ifdef YYDEBUG
		if( yydebug ) printf("reduce %d\n",yyn);
#endif
		yyps -= yyr2[yyn];
		yypvt = yypv;
		yypv -= yyr2[yyn];
		yyval = yypv[1];
		yym=yyn;
			/* consult goto table to find next state */
		yyn = yyr1[yyn];
		yyj = yypgo[yyn] + *yyps + 1;
		if( yyj>=YYLAST || yychk[ yystate = yyact[yyj] ] != -yyn ) yystate = yyact[yypgo[yyn]];
		switch(yym){
			
case 2:
# line 59 "../src/expr.y"
{ Expression = yypvt[-0].eval; } break;
case 3:
# line 63 "../src/expr.y"
{ /* new_procedure( $2, NULL )*/; YYACCEPT; } break;
case 4:
# line 65 "../src/expr.y"
{ /* new_procedure( $2, $3 )*/; YYACCEPT; } break;
case 5:
# line 67 "../src/expr.y"
{ /* new_procedure( $2, $4 )*/; YYACCEPT; } break;
case 6:
# line 70 "../src/expr.y"
{ yyval.aval = NULL; } break;
case 7:
# line 72 "../src/expr.y"
{ yyval.aval = NULL; } break;
case 8:
# line 74 "../src/expr.y"
{ yyval.aval = NULL; } break;
case 9:
# line 78 "../src/expr.y"
{ /* Pargs = add_arg_to_pargs( Pargs, ItsExpr, $2 )*/ ; } break;
case 10:
# line 80 "../src/expr.y"
{ /* Pargs = add_arg_to_pargs( Pargs, $1, $2 )*/; } break;
case 11:
# line 84 "../src/expr.y"
{ yyval.eval = yypvt[-1].eval; } break;
case 12:
# line 86 "../src/expr.y"
{ IfErr( is_lvalue(yypvt[-2].eval) ) { 
	    yyval.eval = NULL; sprintf(ERR_MSG,"left-side of %c%c is non-lvalue",
				yypvt[-1].cval, yypvt[-1].cval=='='? ' ':'=' ); 
	  }
	  else yyval.eval = assignment_expression( yypvt[-1].cval, yypvt[-2].eval, yypvt[-0].eval ); } break;
case 13:
# line 92 "../src/expr.y"
{ yyval.eval = op_expression( '+', yypvt[-2].eval, yypvt[-0].eval ); } break;
case 14:
# line 94 "../src/expr.y"
{ yyval.eval = op_expression( '-', yypvt[-2].eval, yypvt[-0].eval ); } break;
case 15:
# line 96 "../src/expr.y"
{ yyval.eval = op_expression( '*', yypvt[-2].eval, yypvt[-0].eval ); } break;
case 16:
# line 98 "../src/expr.y"
{ yyval.eval = op_expression( '/', yypvt[-2].eval, yypvt[-0].eval ); } break;
case 17:
# line 100 "../src/expr.y"
{ yyval.eval = multi_expression( yypvt[-2].eval, yypvt[-0].eval ); } break;
case 18:
# line 102 "../src/expr.y"
{ yyval.eval = op_expression( '^', yypvt[-2].eval, yypvt[-0].eval ); } break;
case 19:
# line 104 "../src/expr.y"
{ yyval.eval = op_expression( '&', yypvt[-2].eval, yypvt[-0].eval ); } break;
case 20:
# line 106 "../src/expr.y"
{ yyval.eval = op_expression( '|', yypvt[-2].eval, yypvt[-0].eval ); } break;
case 21:
# line 108 "../src/expr.y"
{ yyval.eval = op_expression( yypvt[-1].cval, yypvt[-2].eval, yypvt[-0].eval ); } break;
case 22:
# line 110 "../src/expr.y"
{ yyval.eval = op_expression( yypvt[-1].cval, yypvt[-2].eval, yypvt[-0].eval ); } break;
case 23:
# line 112 "../src/expr.y"
{ yyval.eval = op_expression( '-', constant_expression( 0.0 ), yypvt[-0].eval ); } break;
case 24:
# line 114 "../src/expr.y"
{ yyval.eval = func_expression( yypvt[-2].funcval, yypvt[-1].eval ); } break;
case 25:
# line 116 "../src/expr.y"
{ yyval.eval = randomfunc_expression( yypvt[-2].funcval, yypvt[-1].eval ); } break;
case 26:
# line 118 "../src/expr.y"
{ yyval.eval = range_expression(yypvt[-1].eval, &yypvt[-0].rval); } break;
case 27:
# line 120 "../src/expr.y"
{ yyval.eval = range2_expression(yypvt[-2].eval, &yypvt[-1].rval, &yypvt[-0].rval); } break;
case 28:
# line 122 "../src/expr.y"
{ yyval.eval = terminal_expression( &yypvt[-0].vval ); } break;
case 29:
# line 124 "../src/expr.y"
{ yyval.eval = terminal_expression(&yypvt[-0].vval); } break;
case 30:
# line 126 "../src/expr.y"
{ yyval.eval = column_expression(yypvt[-5].eval,yypvt[-1].eval); } break;
case 31:
# line 128 "../src/expr.y"
{ yyval.eval = constant_expression( yypvt[-0].fval ); } break;
case 32:
# line 132 "../src/expr.y"
{ yyval.fval = yypvt[-0].fval; } break;
case 33:
# line 135 "../src/expr.y"
{ yyval.fval = (float) yypvt[-0].ival; } break;
case 34:
# line 139 "../src/expr.y"
{ yyval.rval.start = yypvt[-3].eval; yyval.rval.end = yypvt[-1].eval; } break;
case 35:
# line 141 "../src/expr.y"
{ yyval.rval.start = yypvt[-1].eval; yyval.rval.end = NULL; } break;
case 36:
# line 143 "../src/expr.y"
{ yyval.rval.start = constant_expression((float)yypvt[-3].ival); 
	  yyval.rval.end = constant_expression((float)yypvt[-3].ival+yypvt[-1].ival-1); } break;
		}
		goto yystack;  /* stack new state and value */

	}

# ifdef YYEUCCCOUNT
yyeuclex()
{
    unsigned short c;
    int i;

    c = yylex();
    if( c < 256 ) return(c);
    for(i=0;i<YYEUCCCOUNT;i++)
        if( c == yyeucctable[i].name )
	    return( yyeucctable[i].val );
    return(c);
}
# endif
    


