#define ENDWHILE 100
#define ENDIF 101
#define ENDREPEAT 102
#define ELSE 103
#define CONTINUE 104
#define SKIP 10
#define NOTSKIP 11
#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif
#define INT 1		/* variable/constant types */
#define FLOAT 2

#define CheckIntArg()    if( procP->n_int >= MaxProcConst ) \
	Erreturn("Sorry, too many integer constants in a procedure");
#define CheckFloatArg()    if( procP->n_float >= MaxProcConst ) \
	Erreturn("Sorry, too many float constants in a procedure");
 
#ifndef AtoI
#define AtoI(s, n)  sscanf( s, "%d", &n ) 
#endif

#ifndef AtoF
#define AtoF(s, x)  sscanf( s, "%f", &x ) 
#endif

/* functions used in network procedures 
	function name			- action name */
#if 0
extern int execute_procedure();		/* call */
extern int execute_procedure_args();	/* call (with arguments) */
#endif 0
extern int executeAprocCheck();		/* call proc/ call proc(arg,..) */
	/* network operations */
extern int input_layer();		/* input */
extern int input_layer_arg();		/* input (with args) */
extern int forward();			/* forward */
extern int forward_arg();		/* forward (with args) */
extern int backward();			/* backward */
extern int backward_arg();		/* backward (with args) */
extern int change_weight();		/* learn */
extern int change_weight_arg();		/* learn (with args) */
extern int change_weight_batch_do();	/* learn (change) */
extern int change_weight_batch_do_arg();/* learn (change, with args) */
extern int change_weight_batch();	/* learn (batch) */
extern int change_weight_batch_arg();	/* learn (batch, with args) */
extern int prune_connection();		/* rewire */
extern int prune_connection_arg();	/* rewire (with args) */
extern int resize_array();		/* resize */
extern int resize_matrix();		/* resize */
extern int resize_layer();		/* resize */
extern int resize_layer_arg();		/* resize (with args) */
extern int resize_layer_connect();	/* resize <layer> connect */
extern int resize_layer_connect_arg();	/* resize <layer> connect (with args) */
extern int copy_to_layer();		/* input */
extern int delta_out_logistic();	/* target */
extern int delta_out_linear();		/* target */
extern int delta_out_arg();		/* target (with args) */
extern int logistic ();			/* activation, logistic */
extern int linear();			/* activation */
extern int activation_arg();		/* activation (with args) */
extern int delta_logistic ();		/* delta */
extern int delta_linear ();		/* delta */
extern int delta_arg();			/* delta (with args) */
extern int clear_layer();		/* clear */
extern int clear_layer_arg();		/* clear (with args) */
extern int clear_delta();		/* cleardelta */
extern int clear_delta_arg();		/* cleardelta (with args) */
extern int change_bias();		/* learnbias */
extern int change_bias_arg();		/* learnbias (with args) */
extern int copy_error();		/* copyerror */
	/* vector manipulation */
extern int copy_vector_();		/* copy */
extern int shift_vector();		/* shift */
extern int add_noise_to_vector();	/* noise */
#if 0
extern int average_vector_();		/* erroraverage, average */
extern int sum_vector_();		/* sum */
extern int random_state();		/* randomstate */
#endif 0
extern int threshold();			/* threshold */
extern int push_vector();		/* push */
extern int push_from_end();		/* pushend */
extern int pop_vector();		/* pop */
extern int pop_from_end();		/* popend */
extern int choose_max();		/* choosemax */
extern int choose_max_threshold();	/* choosemax */
#if 0
extern int index_max();			/* indexmax */
extern int outer_product();		/* oproduct */
#endif 0
extern int clamp_vector();		/* clamp */
extern int ivector_dot_vector();	/* iproduct */
extern int ivector_times_float();	/* iproduct */
extern int ivector_dot_vector_inc();	/* iproduct */
extern int ivector_times_float_inc();	/* iproduct */
extern int make_index();		/* makeindex */
extern int sort_index();		/* sortindex */
	/* expression operations */
extern int evalExpression();		/* expression */
extern int assign_expression();		/* = */
#if 0
extern int set_int_to_int();		/* set */
extern int set_vector_to_int();		/* set */
extern int set_vector_to_float();	/* set */
extern int set_vector_to_vector();	/* set */
#endif 0
	/* control functions */
extern int if_();			/* if */
extern int if_then();			/* if then .. */
extern int if_then_else();		/* if then .. else */
extern int while_do();			/* while */
extern int repeat();			/* repeat */
extern int here_();			/* here */
       
extern int exec_citem();		/* command */

EXPRESS * find_expression();
NUMBER * find_variable();
void substitute_defined_str();
char * make_citem();

extern char SCOPE[];
extern PROCED *procScope;
